\begin{tikzpicture}[framed]
  % Define styles
  \tikzset{node distance=0.42cm}
  \tikzset{
    every place/.style={
      minimum size=5mm, thick, draw=black, fill=white
    }
  }
  \tikzset{
    every transition/.style={
      minimum height=8mm, minimum width=0.5mm, thick, draw=black, fill=black
    }
  }
  \tikzset{
    every pre and post/.style={
      ultra thick, draw=black
    }
  }

  % Define places for Path A3
  \node[] (dots_post_a3) {$\cdots$};
  \node[place, label=above:\textcolor{brown}{$p_{3(14)}$}, right=of dots_post_a3] (p314) {};
  \node[place, label=above:\textcolor{brown}{$q_{3(14)}$}, right=of p314] (q314) {};
  \node[place, label=above:\textcolor{brown}{$p_{3(13)}$}, right=of q314] (p313) {};
  \node[place, label=above:\textcolor{brown}{$q_{3(13)}$}, right=of p313] (q313) {};
  \node[place, label=above:\textcolor{brown}{$p_{3(12)}$}, right=of q313] (p312) {};
  \node[place, label=above:\textcolor{brown}{$q_{3(12)}$}, right=of p312] (q312) {};
  \node[place, label=above:\textcolor{brown}{$p_{3(11)}$}, right=of q312] (p311) {};
  \node[place, label=above:\textcolor{brown}{$q_{3(11)}$}, right=of p311] (q311) {};
  \node[place, label=above:\textcolor{brown}{$p_{3(10)}$}, right=of q311] (p310) {};
  \node[place, label=above:\textcolor{brown}{$q_{3(10)}$}, right=of p310] (q310) {};
  \node[place, label=above:\textcolor{brown}{$p_{39}$}, right=of q310] (p39) {};
  \node[place, label=above:\textcolor{brown}{$q_{39}$}, right=of p39] (q39) {};
  \node[place, label=above:\textcolor{brown}{$p_{38}$}, right=of q39] (p38) {};
  \node[place, label=above:\textcolor{brown}{$q_{38}$}, right=of p38] (q38) {};
  \node[right=of q38] (dots_pre_a3) {$\cdots$};

  % Define places for Path A1
  \node[above=3cm of q314] (dots_post_a1) {$\cdots$};
  \node[place, label=above:\textcolor{teal}{$p_{19}$}, right=of dots_post_a1, tokens=1] (p19) {};
  \node[place, label=above:\textcolor{teal}{$q_{19}$}, right=of p19] (q19) {};
  \node[place, label=above:\textcolor{teal}{$p_{18}$}, right=of q19] (p18) {};
  \node[place, label=above:\textcolor{teal}{$q_{18}$}, right=of p18] (q18) {};
  \node[place, label=above:\textcolor{teal}{$p_{17}$}, right=of q18] (p17) {};
  \node[place, label=above:\textcolor{teal}{$q_{17}$}, right=of p17] (q17) {};
  \node[place, label=above:\textcolor{teal}{$p_{16}$}, right=of q17] (p16) {};
  \node[place, label=above:\textcolor{teal}{$q_{16}$}, right=of p16] (q16) {};
  \node[place, label=above:\textcolor{teal}{$p_{15}$}, right=of q16] (p15) {};
  \node[place, label=above:\textcolor{teal}{$q_{15}$}, right=of p15] (q15) {};
  \node[right=of q15] (dots_pre_a1) {$\cdots$};

  % Define places for cells
  \node[place, label=below:$c_{12}$, above=1.5cm of p313] (c12) {};
  \node[place, label=below:$c_{22}$, above=1.5cm of p312] (c22) {};
  \node[place, label=below:$c_{32}$, above=1.5cm of p310, tokens=1] (c32) {};
  \node[place, label=below:$c_{42}$, above=1.5cm of p39, tokens=1] (c42) {};

  \node[place, label=below:$c_{21}$, above=1.5cm of q313, tokens=1] (c21) {};
  \node[place, label=below:$c_{11}$, above=1.5cm of q314, tokens=1] (c11) {};

  \node[place, label=below:$c_{33}$, above=1.5cm of p38] (c33) {};
  \node[place, label=below:$c_{43}$, above=1.5cm of q38] (c43) {};

  % Define transitions with arrows for Path A1
  \node[transition, label=below:\textcolor{teal}{$t_{1(10)}$}] (t110) at ($(dots_post_a1)!0.5!(p19)$) {}
    edge [post] (dots_post_a1)
    edge [pre] (p19);
  \node[transition, label=below:\textcolor{teal}{$u_{19}$}] (u19) at ($(p19)!0.5!(q19)$) {}
    edge [post] (p19)
    edge [pre] (q19);
  \node[transition, label=below:\textcolor{teal}{$t_{19}$}] (t19) at ($(q19)!0.5!(p18)$) {}
    edge [post] (q19)
    edge [pre] (p18)
    edge [pre] (c12);
  \node[transition, label=below:\textcolor{teal}{$u_{18}$}] (u18) at ($(p18)!0.5!(q18)$) {}
    edge [post] (p18)
    edge [post] (c32)
    edge [pre] (q18);
  \node[transition, label=below:\textcolor{teal}{$t_{18}$}] (t18) at ($(q18)!0.5!(p17)$) {}
    edge [post] (q18)
    edge [pre] (p17);
  \node[transition, label=below:\textcolor{teal}{$u_{17}$}] (u17) at ($(p17)!0.5!(q17)$) {}
    edge [post] (p17)
    edge [pre] (q17);
  \node[transition, label=below:\textcolor{teal}{$t_{17}$}] (t17) at ($(q17)!0.5!(p16)$) {}
    edge [post] (q17)
    edge [pre] (p16)
    edge [pre] (c22);
  \node[transition, label=below:\textcolor{teal}{$u_{16}$}] (u16) at ($(p16)!0.5!(q16)$) {}
    edge [post] (p16)
    edge [post] (c42)
    edge [pre] (q16);
  \node[transition, label=below:\textcolor{teal}{$t_{16}$}] (t16) at ($(q16)!0.5!(p15)$) {}
    edge [post] (q16)
    edge [pre] (p15);
  \node[transition, label=below:\textcolor{teal}{$u_{15}$}] (u15) at ($(p15)!0.5!(q15)$) {}
    edge [post] (p15)
    edge [pre] (q15);
  \node[transition, label=below:\textcolor{teal}{$t_{15}$}] (t15) at ($(q15)!0.5!(dots_pre_a1)$) {}
    edge [post] (q15)
    edge [pre] (c32)
    edge [pre] (dots_pre_a1);

  % Define transitions with arrows for Path A3
  \node[transition, label=below:\textcolor{brown}{$u_{3(15)}$}] (u315) at ($(dots_post_a3)!0.5!(p314)$) {}
    edge [post] (dots_post_a3)
    edge [pre] (p314);
  \node[transition, label=below:\textcolor{brown}{$u_{3(14)}$}] (u314) at ($(p314)!0.5!(q314)$) {}
    edge [post] (p314)
    edge [pre] (q314);
  \node[transition, label=below:\textcolor{brown}{$t_{3(14)}$}] (t314) at ($(q314)!0.5!(p313)$) {}
    edge [post] (q314)
    edge [pre] (p313)
    edge [pre] (c11)
    edge [pre] (c12);
  \node[transition, label=below:\textcolor{brown}{$u_{3(13)}$}] (u313) at ($(p313)!0.5!(q313)$) {}
    edge [post] (p313)
    edge [pre] (q313);
  \node[transition, label=below:\textcolor{brown}{$t_{3(13)}$}] (t313) at ($(q313)!0.5!(p312)$) {}
    edge [post] (q313)
    edge [pre] (p312)
    edge [pre] (c21);
  \node[transition, label=below:\textcolor{brown}{$u_{3(12)}$}] (u312) at ($(p312)!0.5!(q312)$) {}
    edge [post] (p312)
    edge [pre] (q312)
    edge [post] (c32);
  \node[transition, label=below:\textcolor{brown}{$t_{3(12)}$}] (t312) at ($(q312)!0.5!(p311)$) {}
    edge [post] (q312)
    edge [pre] (p311);
  \node[transition, label=below:\textcolor{brown}{$u_{3(11)}$}] (u311) at ($(p311)!0.5!(q311)$) {}
    edge [post] (p311)
    edge [pre] (q311);
  \node[transition, label=below:\textcolor{brown}{$t_{3(11)}$}] (t311) at ($(q311)!0.5!(p310)$) {}
    edge [post] (q311)
    edge [pre] (p310)
    edge [pre] (c22);
  \node[transition, label=below:\textcolor{brown}{$u_{3(10)}$}] (u310) at ($(p310)!0.5!(q310)$) {}
    edge [post] (p310)
    edge [pre] (q310)
    edge [post] (c33);
  \node[transition, label=below:\textcolor{brown}{$t_{3(10)}$}] (t310) at ($(q310)!0.5!(p39)$) {}
    edge [post] (q310)
    edge [pre] (p39);
  \node[transition, label=below:\textcolor{brown}{$u_{39}$}] (u39) at ($(p39)!0.5!(q39)$) {}
    edge [post] (p39)
    edge [post] (c43)
    edge [post] (c42)
    edge [pre] (q39);
  \node[transition, label=below:\textcolor{brown}{$t_{39}$}] (t39) at ($(q39)!0.5!(p38)$) {}
    edge [post] (q39)
    edge [pre] (p38);
  \node[transition, label=below:\textcolor{brown}{$u_{38}$}] (u38) at ($(p38)!0.5!(q38)$) {}
    edge [post] (p38)
    edge [pre] (q38);
  \node[transition, label=below:\textcolor{brown}{$t_{38}$}] (t38) at ($(q38)!0.5!(dots_pre_a3)$) {}
    edge [post] (q38)
    edge [pre] (c32)
    edge [pre] (c42)
    edge [pre] (dots_pre_a3);

  \draw[->] (c42) -- (dots_pre_a1.south);
  \draw[->] (dots_post_a1.south) -- (c22);
  \draw[->] (dots_post_a1.south) -- (c12);

  \draw[<-] (dots_pre_a3.north) -- (c33);
  \draw[<-] (dots_pre_a3.north) -- (c43);

  \draw[->] (dots_post_a3.north) -- (c22);
  \draw[->] (dots_post_a3.north) -- (c21);
  \draw[->] (dots_post_a3.north) -- (c11);
  \draw[->] (dots_post_a3.north) -- (c12);

\end{tikzpicture}
